#line 1 "C:/Users/ASUSUSER/Documents/UART_TXT_TEST/SW/uart_test.c"




void TMR1_Handle (void);
void RC_Handle (void);
void UART_TX (char dat);
void UART_TX_TEXT ( char *dat);
void buffer_clear (void);

volatile unsigned char buffer[ 80 ];
volatile unsigned char buffer_cnt=0;
volatile unsigned char buffer_lock=0;
volatile unsigned char tim1_cnt=0;
volatile unsigned char data_ready=0;

void main()
{
 SPBRG=129;
 TXSTA=(1<<TXEN)|(1<<BRGH);
 RCSTA=(1<<SPEN)|(1<<CREN);
 T1CON=(1<<T1CKPS1)|(1<<T1CKPS0)|(1<<TMR1ON);
 INTCON=(1<<GIE)|(1<<PEIE);
 PIE1=(1<<TMR1IE)|(1<<RCIE);
 TRISA=0;
 UART_TX_TEXT("HELLO!");
 while(1)
 {
 while (data_ready!= 2 );
 UART_TX(13);
 UART_TX(10);
 UART_TX_TEXT(buffer);
 buffer_clear();
 data_ready=0;
 }
}

void interrupt (void)
{
 if (PIR1.TMR1IF) {TMR1_Handle(); PIR1.TMR1IF=0;}
 if (PIR1.RCIF) {RC_Handle(); PIR1.RCIF=0;}
}

void TMR1_Handle (void)
{
 tim1_cnt++;
 if (tim1_cnt==10)
 {
 PORTA=~PORTA;
 tim1_cnt=0;
 if (buffer_cnt)
 {
 data_ready= 2 ;
 buffer_cnt=0;
 }
 }
}


void RC_Handle (void)
{
 buffer[buffer_cnt]=RCREG;
 if (buffer_cnt!= 80 ) buffer_cnt++;
 else buffer_cnt=0;
 tim1_cnt=0;
 data_ready= 1 ;
}

void UART_TX (char dat)
{
 while(!PIR1.TXIF);
 TXREG=dat;
 PIR1.TXIF=0;
}

void UART_TX_TEXT ( char *dat)
{
 while (*dat) UART_TX (*dat++);
 UART_TX(13);
 UART_TX(10);
}

void buffer_clear (void)
{
 unsigned char cnt;
 for (cnt=0; cnt!= 80 ; cnt++) buffer[cnt]=0;
}
